'                                  DIAGRAM.BAS
'
'      tracciamento dei diagrammi delle caratteristiche di sollecitazione
'
'                                                                 rev. 09.89


' ------------------ Dichiarazione delle procedure utilizzate ------------------

' procedure del file ASTA.BAS
DECLARE SUB Carsol.AzEstr (Fx!, Fy!, Mz!, X!, L!, Sn!, Mf!, Ta!)
DECLARE SUB Carsol.FM (Fx!, Fy!, Mz!, X0!, X!, L!, Sn!, Mf!, Ta!)
DECLARE SUB CarSol.Qunif (Q!, N!, X!, L!, Sn!, Mf!, Ta!)
DECLARE SUB Carsol.Qvar (Q1!, Q2!, X1!, X2!, X!, L!, Mf!, Ta!)

' procedure di questo file
DECLARE SUB Diagramma (X1!, Y1!, X2!, Y2!, S!(), P!(), F!(), Xf!(), Q!(), Xq!(), Sc!, CS!)

' --------------------------- Programma principale -----------------------------

SCREEN 0

' lettura della geometria dello schema
READ IZ, JZ                      ' numero di nodi e di aste
DIM X(IZ), Y(IZ), E1(JZ), E2(JZ), S(3), P(2), F(3, 3), Xf(3), Q(2, 2), Xq(2, 2)
FOR I = 1 TO IZ
   READ X(I), Y(I)               ' coordinate dei nodi
NEXT I
FOR J = 1 TO JZ
   READ E1(J), E2(J)             ' nodi di estremita` delle aste
NEXT J
READ Xmin, Xmax, Ymin, Ymax      ' estremi dell'area grafica
READ Sc                          ' fattore di scala per i diagrammi

DO

   ' chiede quale diagramma visualizzare
   CLS
   LOCATE 3, 28: PRINT "DIAGRAM.BAS - rev. 09.89"
   PRINT
   PRINT "      Esempio di utilizzazione della procedura  Diagramma  per il disegno"
   PRINT "      dei diagrammi delle caratteristiche di sollecitazione in un telaio."
   PRINT
   PRINT "      Il programma e` descritto nel capitolo 4, parte seconda, del libro:"
   PRINT "      A.Ghersi, R.Coraggio,  Il personal computer nel calcolo di edifici."
   PRINT "      Analisi matriciale  di strutture intelaiate,  CUEN,  Napoli,  1990."
   PRINT
   PRINT "      ATTENZIONE: Il programma richiede scheda grafica CGA o equivalente."
   PRINT
   PRINT
   PRINT "      Scegli il diagramma da visualizzare:"
   PRINT
   PRINT "      Schema di carico 1                         Schema di carico 2"
   PRINT
   PRINT "      1 - sforzo normale                         4 - sforzo normale"
   PRINT "      2 - momento flettente                      5 - momento flettente"
   PRINT "      3 - taglio                                 6 - taglio"
   PRINT
   PRINT "                           0 - fine esecuzione"
   DO
      K$ = INKEY$
   LOOP UNTIL K$ <> ""
   K = ASC(K$) - 48
   SELECT CASE K
      CASE 1, 2, 3
         RESTORE Schema1
         CS = K
      CASE 4, 5, 6
         RESTORE Schema2
         CS = K - 3
      CASE ELSE
   END SELECT
   IF K >= 1 AND K <= 6 THEN
      SCREEN 2
      WINDOW (Xmin, Ymin)-(Xmax, Ymax)
      CLS
      LOCATE 1, 26
      SELECT CASE CS
         CASE 1
            PRINT "DIAGRAMMA  DELLO SFORZO NORMALE"
         CASE 2
            PRINT "DIAGRAMMA DEL MOMENTO FLETTENTE"
         CASE 3
            PRINT "      DIAGRAMMA DEL TAGLIO"
      END SELECT
      ' lettura dei carichi sulle aste e disegno diagramma
      FOR J = 1 TO JZ
         READ S(1), S(2), S(3)                          ' azioni di estremita`
         READ P(1), P(2)                                ' carichi uniformi
         FOR N = 1 TO 3
            READ F(1, N), F(2, N), F(3, N), Xf(N)       ' azioni concentrate
         NEXT N
         FOR N = 1 TO 2
            READ Q(1, N), Q(2, N), Xq(1, N), Xq(2, N)   ' carichi variabili
         NEXT N
         X1 = X(E1(J))
         Y1 = Y(E1(J))
         X2 = X(E2(J))
         Y2 = Y(E2(J))
         CALL Diagramma(X1, Y1, X2, Y2, S(), P(), F(), Xf(), Q(), Xq(), Sc, CS)
      NEXT J
      LOCATE 24, 1
      PRINT "Per continuare premi un tasto qualsiasi";
      DO
         K$ = INKEY$
      LOOP UNTIL K$ <> ""
   END IF

LOOP UNTIL K = 0
SCREEN 0
END
   
DATA 5,4
DATA 0,0,0,5,4,8,8,5,8,0
DATA 1,2,2,3,3,4,4,5
DATA -6,14,-3,10
DATA .01

Schema1:
DATA -200,128.30,-58.14,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0
DATA -166.51,-162.40,125.12,-24,-32
DATA 0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0
DATA -46.51,63.18,34.88,24,-32
DATA 0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0
DATA -200,-162.40,58.14,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0

Schema2:
DATA -141.43,36.89,-25.23,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0
DATA -105.04,-89.28,98.00,0,0
DATA -60,-80,0,1.875,-60,-80,0,3.125,0,0,0,0
DATA 0,0,0,0,0,0,0,0
DATA -55.33,0.75,-31.72,0,0
DATA 0,0,-100,2.5,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0
DATA -58.57,-57.83,25.23,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0

' ================================ Diagramma ===================================
'
'   Procedura per il disegno del diagramma
'   del momento flettente, del taglio o dello sforzo normale
'
'   NOTE: occorre essersi gia` posizionati nella modalita` grafica (SCREEN)
'         ed aver definito il campo di coordinate (WINDOW)
'
'   Variabili di ingresso:
'      X1        ascissa  del primo estremo dell'asta
'      Y1        ordinata del primo estremo dell'asta
'      X2        ascissa  del secondo estremo dell'asta
'      Y2        ordinata del secondo estremo dell'asta
'      S()       array che contiene le caratt. di sollecitaz. al primo estremo
'                   indice:  1 -> N,  2 -> M,  3 -> T
'      P()       array che contiene le componenti del carico uniforme sull'asta
'                   indice:  1 -> Px, 2 -> Py
'      F()       array bidimensionale che contiene le azioni concentrate
'                   primo indice:  1 -> Fx, 2 -> Fy, 3 -> Mz
'                   secondo indice: numero d'ordine della forza (1-3)
'      Xf()      vettore ascisse punti applicazione azioni concentrate (1-3)
'      Q()       array bidimensionale che contiene i carichi variabili
'                   primo indice:  1 -> Q1, 2 -> Q2
'                   secondo indice: numero d'ordine dei carichi (1-2)
'      Xq()      array bidimensionale che contiene le ascisse dei car. variabili
'                   primo indice:  1 -> X1, 2 -> X2
'                   secondo indice: numero d'ordine dei carichi (1-2)
'      Sc        fattore di scala della caratteristica da diagrammare
'      CS        caratteristica di sollecitazione da diagrammare:
'                   1 = sforzo normale
'                   2 = momento flettente
'                   3 = taglio
'
'   Variabili di uscita:
'      ===
'
'   Principali variabili interne:
'      L         lunghezza dell'asta
'      X         ascissa variabile
'      Nx,Mx,Tx  caratteristiche di sollecitazione all'ascissa X
'      XP,YP     coordinate del punto del diagramma
'      Punti     numero di punti dell'asta nei quali sono calcolati N, M, T
'
'   Procedure utilizzate:
'      CarSol.AzEstr
'      CarSol.FM
'      CarSol.Qunif
'      CarSol.Qvar
'
' ------------------------------------------------------------------------------
'
SUB Diagramma (X1, Y1, X2, Y2, S(), P(), F(), Xf(), Q(), Xq(), Sc, CS)

    Punti = 100


    ' calcola lunghezza asta e sue proiezioni
    Dx = X2 - X1
    Dy = Y2 - Y1
    L = SQR(Dx ^ 2 + Dy ^ 2)
    SnAl = Dy / L
    CsAl = Dx / L

    ' disegna l'asta
    LINE (X1, Y1)-(X2, Y2)

    ' disegna il diagramma
    PSET (X1, Y1)
    Xprec = 0
    FOR J = 1 TO 4
       IF J = 4 THEN
          Xsucc = L
       ELSE
          Xsucc = Xf(J)
       END IF
       DeltaX = Xsucc - Xprec
       IF Xsucc <> 0 AND DeltaX <> 0 THEN
          IF DeltaX < 0 THEN
             PRINT "ERRORE 1 in Diagramma - le azioni concentrate non sono assegnate"
             PRINT "                        nell'ordine in cui si succedono lungo l'asta"
             END
          END IF
          SZ = INT(DeltaX / L * Punti + 1)
          FOR S = 0 TO SZ
             X = Xprec + S * DeltaX / SZ
             GOSUB CalcolaCarSol
             GOSUB TracciaDiagr
          NEXT S
          Xprec = Xsucc
       END IF
    NEXT J
    LINE -(X2, Y2)
    EXIT SUB

CalcolaCarSol:
   
    ' per azioni di estremita`
    CALL Carsol.AzEstr(-S(1), S(3), -S(2), X, L, Nx, Mx, Tx)
    ' per carichi uniformemente distribuiti
    IF P(1) <> 0 OR P(2) <> 0 THEN
       CALL CarSol.Qunif(P(2), P(1), X, L, Sn, Mf, Ta)
       Nx = Nx + Sn
       Mx = Mx + Mf
       Tx = Tx + Ta
    END IF
    ' per forze e coppie concentrate
    FOR J = 1 TO 3
       IF F(1, J) <> 0 OR F(2, J) <> 0 OR F(3, J) <> 0 THEN
          CALL Carsol.FM(F(1, J), F(2, J), F(3, J), Xf(J), X, L, Sn, Mf, Ta)
          Nx = Nx + Sn
          Mx = Mx + Mf
          Tx = Tx + Ta
       END IF
    NEXT J
    ' per carichi distribuiti con legge lineare
    FOR J = 1 TO 2
       IF Q(1, J) <> 0 OR Q(2, J) <> 0 THEN
          CALL Carsol.Qvar(Q(1, J), Q(2, J), Xq(1, J), Xq(2, J), X, L, Mf, Ta)
          Mx = Mx + Mf
          Tx = Tx + Ta
       END IF
    NEXT J

RETURN

TracciaDiagr:

    SELECT CASE CS
       CASE 1
          V = Nx * Sc
       CASE 2
          V = -Mx * Sc
       CASE 3
          V = Tx * Sc
    END SELECT
    XP = X1 + X * CsAl - V * SnAl
    YP = Y1 + X * SnAl + V * CsAl
    LINE -(XP, YP)
   
RETURN

END SUB

