'                                  MATRIX.BAS
'
'                    procedure per le operazioni matriciali
'
'                                                                 rev. 09.89
'


' ------------------ Dichiarazione delle procedure utilizzate ------------------

DECLARE SUB AzzeraMat1 (A!(), NRA!)
DECLARE SUB AzzeraMat2 (A!(), NRA!, NCA!)
DECLARE SUB CostanteMat1 (V!, A!(), NRA!)
DECLARE SUB CostanteMat2 (V!, A!(), NRA!, NCA!)
DECLARE SUB DuplicaMat (A!(), B!())
DECLARE SUB DuplicaMat1 (A!(), NRA!, B!())
DECLARE SUB DuplicaMat2 (A!(), NRA!, B!())
DECLARE SUB DuplicaMat3 (A!(), NRA!, B!())
DECLARE SUB DuplicaMat4 (A!(), NRA!, NCA!, B!())
DECLARE SUB InputMat1 (A!(), F!, NRA!)
DECLARE SUB InputMat2 (A!(), F!, NRA!, NCA!)
DECLARE SUB InserMat1 (A!(), NRA!, RI!, B!())
DECLARE SUB InserMat2 (A!(), NRA!, RI!, CI!, B!())
DECLARE SUB InserMat3 (A!(), NRA!, NCA!, RI!, CI!, B!())
DECLARE SUB LimitiMat (A!(), DA!, LR!, LC!, NR!, NC!)
DECLARE SUB OutputMat (A!(), F!, F$)
DECLARE SUB OutputMat1 (A!(), F!, F$, NRA!)
DECLARE SUB OutputMat2 (A!(), F!, F$, NRA!, NCA!)
DECLARE SUB ProdottoCostMat1 (K!, A!(), NRA!, B!())
DECLARE SUB ProdottoCostMat2 (K!, A!(), NRA!, NCA!, B!())
DECLARE SUB ProdottoMat1 (A!(), B!(), NRA!, NCB!, C!())
DECLARE SUB ProdottoMat2 (A!(), B!(), NRA!, NCA!, C!())
DECLARE SUB ProdottoMat3 (A!(), B!(), NRA!, NCB!, NCA!, C!())
DECLARE SUB SommaMat1 (A!(), B!(), NRA!, C!())
DECLARE SUB SommaMat2 (A!(), B!(), NRA!, NCA!, C!())
DECLARE SUB SottraeMat1 (A!(), B!(), NRA!, C!())
DECLARE SUB SottraeMat2 (A!(), B!(), NRA!, NCA!, C!())
DECLARE SUB TrasponeMat1 (A!(), NRA!, B!())
DECLARE SUB TrasponeMat2 (A!(), NRA!, NCA!, B!())
DECLARE SUB WriteMat1 (A!(), F!, NRA!)
DECLARE SUB WriteMat2 (A!(), F!, NRA!, NCA!)

ErroreLimitiMat:
    RESUME NEXT

' ================================ AzzeraMat ===================================
'
'   Procedura per l'azzeramento di un array monodimensionale o bidimensionale
'
'   Variabili di ingresso:
'      A()       array da azzerare
'
'   Variabili di uscita:
'      A()       array azzerato
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB AzzeraMat (A())
    
    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in AzzeraMat - limiti inferiori di A maggiori di 1"
       END
    END IF

    ' azzera l'array
    IF DA = 1 THEN
       CALL AzzeraMat1(A(), NRA)
    ELSE
       CALL AzzeraMat2(A(), NRA, NCA)
    END IF

END SUB

SUB AzzeraMat1 (A(), NRA)

    FOR R = 1 TO NRA
       A(R) = 0
    NEXT R

END SUB

SUB AzzeraMat2 (A(), NRA, NCA)

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          A(R, C) = 0
       NEXT C
    NEXT R

END SUB

' ================================ CostanteMat =================================
'
'   Procedura per la creazione di un array (monodimensionale o bidimensionale)
'   con tutti gli elementi identicamente uguali ad un valore assegnato
'
'   Variabili di ingresso:
'      V         valore da assegnare agli elementi dell'array
'
'   Variabili di uscita:
'      A()       array ottenuto
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB CostanteMat (V, A())
    
    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in CostanteMat - limiti inferiori di A maggiori di 1"
       END
    END IF

    ' assegna il valore agli elementi dell'array
    IF DA = 1 THEN
       CALL CostanteMat1(V, A(), NRA)
    ELSE
       CALL CostanteMat2(V, A(), NRA, NCA)
    END IF

END SUB

SUB CostanteMat1 (V, A(), NRA)

    FOR R = 1 TO NRA
       A(R) = V
    NEXT R
    
END SUB

SUB CostanteMat2 (V, A(), NRA, NCA)

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          A(R, C) = V
       NEXT C
    NEXT R

END SUB

' ================================ DuplicaMat ==================================
'
'   Procedura per duplicare un array monodimensionale o bidimensionale;
'   consente anche di duplicare  un vettore colonna  in una matrice con
'   una sola colonna, e viceversa
'
'   Variabili in ingresso:
'      A()       array da duplicare
'
'   Variabili in uscita:
'      B()       array duplicato di A()
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB DuplicaMat (A(), B())
    
    ' determina il numero di righe e colonne degli array A e B
    ' controlla che il numero di righe e colonne sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 THEN
       CLS
       PRINT "ERRORE 1 in DuplicaMat - limiti inferiori di A o B maggiori di 1"
       END
    END IF
    IF NRA <> NRB OR NCA <> NCB THEN
       CLS
       PRINT "ERRORE 2 in DuplicaMat - numero di righe e colonne di A e B"
       PRINT "                         non compatibili tra loro"
       END
    END IF

    ' duplica l'array
    IF DA = 1 AND DB = 1 THEN
       CALL DuplicaMat1(A(), NRA, B())
    ELSEIF DA = 1 AND DB = 2 THEN
       CALL DuplicaMat2(A(), NRA, B())
    ELSEIF DA = 2 AND DB = 1 THEN
       CALL DuplicaMat3(A(), NRA, B())
    ELSE
       CALL DuplicaMat4(A(), NRA, NCA, B())
    END IF

END SUB

SUB DuplicaMat1 (A(), NRA, B())

    FOR R = 1 TO NRA
       B(R) = A(R)
    NEXT R

END SUB

SUB DuplicaMat2 (A(), NRA, B())

    FOR R = 1 TO NRA
       B(R, 1) = A(R)
    NEXT R

END SUB

SUB DuplicaMat3 (A(), NRA, B())

    FOR R = 1 TO NRA
       B(R) = A(R, 1)
    NEXT R

END SUB

SUB DuplicaMat4 (A(), NRA, NCA, B())

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          B(R, C) = A(R, C)
       NEXT C
    NEXT R

END SUB

' ================================ IdentitaMat =================================
'
'   Procedura per la creazione di una matrice identita` ovvero una matrice
'   quadrata con  gli elementi della diagonale principale  uguali ad uno e
'   tutti gli altri nulli
'
'   Variabili di ingresso:
'      ===
'
'   Variabili di uscita:
'      A()       matrice identita'
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB IdentitaMat (A())
   
    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in IdentitaMat - limiti inferiori di A maggiori di 1"
       END
    END IF
    IF NRA <> NCA THEN
       CLS
       PRINT "ERRORE 2 in IdentitaMat - matrice A non quadrata"
       END
    END IF

    ' crea matrice identita'
    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          IF R = C THEN
            A(R, C) = 1
          ELSE
            A(R, C) = 0
          END IF
       NEXT C
    NEXT R

END SUB

' ================================ InputMat ====================================
'
'   Procedura per l'input di un array monodimensionale o bidimensionale;
'   l'array viene letto da un file gia` aperto nel programma principale
'
'   Variabili di ingresso:
'      A()       array da leggere
'      F         buffer del file da cui leggere l'array
'
'   Variabili di uscita:
'      ===
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB InputMat (A(), F)

    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in InputMat - limiti inferiori di A maggiori di 1"
       END
    END IF

    ' effettua l'input dell'array
    IF DA = 1 THEN
       CALL InputMat1(A(), F, NRA)
    ELSE
       CALL InputMat2(A(), F, NRA, NCA)
    END IF

END SUB

SUB InputMat1 (A(), F, NRA)

    FOR R = 1 TO NRA
       INPUT #F, A(R)
    NEXT R

END SUB

SUB InputMat2 (A(), F, NRA, NCA)

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          INPUT #F, A(R, C)
       NEXT C
    NEXT R

END SUB

' ================================ InserMat ====================================
'
'   Procedura per l'inserimento di un array monodimensionale o bidimensionale
'   in un array di dimensioni pari o maggiori
'
'   Variabili di ingresso:
'      A()       sottoarray da inserire
'      B()       array in cui inserire
'      RI        riga iniziale
'      CI        colonna iniziale
'
'   Variabili di uscita:
'      B()       array risultante
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB InserMat (A(), B(), RI, CI)

    ' determina il numero di indici e di righe e colonne degli array A e B
    ' controlla che il numero di righe e colonne di A e B sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 THEN
       CLS
       PRINT "ERRORE 1 in InserMat - limiti inferiori di A o B maggiori di 1"
       END
    END IF
    IF DA > DB THEN
       CLS
       PRINT "ERRORE 2 in InserMat - array di dimensioni incompatibili"
       END
    END IF
    IF (NRB - RI + 1) < NRA THEN
       CLS
       PRINT "ERRORE 3 in InserMat - sottoarray non inseribile"
       END
    END IF
    IF DA = 2 AND (NCB - CI + 1) < NCA THEN
       CLS
       PRINT "ERRORE 3 in InserMat - sottoarray non inseribile"
       END
    END IF
    IF RI < 1 OR (DB = 2 AND CI < 1) THEN
       CLS
       PRINT "ERRORE 4 in InserMat - riga o colonna iniziale minore di 1"
       END
    END IF
      
    ' inserisce array
    IF DA = 1 AND DB = 1 THEN
       CALL InserMat1(A(), NRA, RI, B())
    ELSEIF DA = 1 AND DB = 2 THEN
       CALL InserMat2(A(), NRA, RI, CI, B())
    ELSE
       CALL InserMat3(A(), NRA, NCA, RI, CI, B())
    END IF

END SUB

SUB InserMat1 (A(), NRA, RI, B())

    FOR R = 1 TO NRA
       B(RI - 1 + R) = A(R)
    NEXT R

END SUB

SUB InserMat2 (A(), NRA, RI, CI, B())

    FOR R = 1 TO NRA
       B(RI - 1 + R, CI) = A(R)
    NEXT R

END SUB

SUB InserMat3 (A(), NRA, NCA, RI, CI, B())

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          B(RI - 1 + R, CI - 1 + C) = A(R, C)
       NEXT C
    NEXT R
    
END SUB

' ================================ InversaMat ==================================
'
'   Procedura per l'inversione di una matrice A()
'
'   Variabili di ingresso:
'      A()          matrice da invertire
'
'   Variabili di uscita:
'      A()          matrice invertita
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB InversaMat (A())
  
    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in InversaMat - limiti inferiori di A maggiori di 1"
       END
    END IF
    IF NRA <> NCA THEN
       CLS
       PRINT "ERRORE 2 in InversaMat - matrice A non quadrata"
       END
    END IF
    N = NRA
    DIM M(N), C(N)
    ' prepara il vettore di controllo
    FOR I = 1 TO N
       M(I) = -I
    NEXT I
    '
    ' ciclo da ripetere N volte
    '
    FOR K = 1 TO N
       ' individua l'elemento maggiore, in valore assoluto, della matrice
       D = 0
       FOR I = 1 TO N
          IF M(I) < 0 THEN
             FOR J = 1 TO N
                IF M(J) < 0 THEN
                   IF ABS(D) < ABS(A(I, J)) THEN
                      R = I
                      C = J
                      D = A(R, C)
                   END IF
                END IF
             NEXT J
          END IF
       NEXT I
       IF ABS(D) < 1E-30 THEN
          CLS
          PRINT "ERRORE 3 in InversaMat - matrice singolare"
          END
       END IF
       ' scambia le colonne
       M(C) = -M(C)
       SWAP M(C), M(R)
       FOR I = 1 TO N
          C(I) = A(I, C)
          SWAP A(I, C), A(I, R)
       NEXT I
       ' divide la riga per l'elemento maggiore
       FOR J = 1 TO N
          IF J <> R THEN A(R, J) = A(R, J) / D
       NEXT J
       ' azzera i restanti termini della colonna
       FOR I = 1 TO N
          IF I <> R THEN
             FOR J = 1 TO N
                IF J <> R THEN A(I, J) = A(I, J) - C(I) * A(R, J)
             NEXT J
          END IF
       NEXT I
       ' memorizza nella colonna i fattori di riduzione
       C(R) = -1
       FOR I = 1 TO N
          A(I, R) = -C(I) / D
       NEXT I
    NEXT K
    '
    ' scambia le righe
    FOR K = 1 TO N
       FOR I = 1 TO N
          IF M(I) = K THEN
             SWAP M(I), M(K)
             FOR J = 1 TO N
                SWAP A(I, J), A(K, J)
             NEXT J
          END IF
       NEXT I
    NEXT K

END SUB

' ================================ LimitiMat ===================================
'
'   Procedura per la determinazione del numero di dimensioni
'   e di righe e colonne di un array monodimensionale o bidimensionale
'
'   Variabili di ingresso:
'      A()    array in esame
'
'   Variabili di uscita:
'      DA     numero di dimensioni dell'array (1 o 2)
'      LR     primo indice di riga
'      LC     primo indice di colonna
'      NR     secondo indice di riga
'      NC     secondo indice di colonna (se l'array e` monodimensionale vale 1)
'
'   Procedure utilizzate:
'      ===
'
'   Annotazioni:
'      la procedura non controlla se il numero di dimensioni e` superiore a 2
'
' ------------------------------------------------------------------------------
'
SUB LimitiMat (A(), DA, LR, LC, NR, NC)

    LR = LBOUND(A, 1)
    NR = UBOUND(A, 1)
    ON ERROR GOTO ErroreLimitiMat
       LC = LBOUND(A, 2)
       NC = UBOUND(A, 2)
    ON ERROR GOTO 0
    IF LC = 0 AND NC = 0 THEN
       DA = 1
       NC = 1
    ELSE
       DA = 2
    END IF
          
END SUB

' ================================ LprintMat ===================================
'
'   Procedura per la stampa su carta
'   di un array monodimensionale o bidimensionale
'
'   Variabili di ingresso:
'      A()       array da stampare
'      F$        stringa di formattazione per l'output
'                (se F$="" si usa il formato libero)
'
'   Variabili di uscita:
'      ===
'
'   Procedure utilizzate:
'      OutputMat
'
' ------------------------------------------------------------------------------
'
SUB LprintMat (A(), F$)

    F = FREEFILE
    OPEN "O", #F, "PRN"
    CALL OutputMat(A(), F, F$)
    CLOSE #F

END SUB

' ================================ OutputMat ===================================
'
'   Procedura per l'output di un array monodimensionale o bidimensionale;
'   l'output viene inviato a un file gia` aperto nel programma principale
'
'   Variabili di ingresso:
'      A()       array da stampare
'      F         buffer del file a cui inviare l'output
'      F$        stringa di formattazione per l'output
'                (se F$="" si usa il formato libero)
'
'   Variabili di uscita:
'      ===
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB OutputMat (A(), F, F$)

    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in OutputMat - limiti inferiori di A maggiori di 1"
       END
    END IF

    ' effettua l'output dell'array
    IF DA = 1 THEN
       CALL OutputMat1(A(), F, F$, NRA)
    ELSE
       CALL OutputMat2(A(), F, F$, NRA, NCA)
    END IF

END SUB

SUB OutputMat1 (A(), F, F$, NRA)

    FOR R = 1 TO NRA
       IF F$ = "" THEN
          PRINT #F, A(R)
       ELSE
          PRINT #F, USING F$; A(R)
       END IF
    NEXT R

END SUB

SUB OutputMat2 (A(), F, F$, NRA, NCA)

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          IF F$ = "" THEN
             PRINT #F, A(R, C),
          ELSE
             PRINT #F, USING F$; A(R, C),
          END IF
       NEXT C
       PRINT #F,
    NEXT R

END SUB

' ================================ PrintMat ====================================
'
'   Procedura per la stampa su schermo
'   di un array monodimensionale o bidimensionale
'
'   Variabili di ingresso:
'      A()       array da stampare
'      F$        stringa di formattazione per l'output
'                (se F$="" si usa il formato libero)
'
'   Variabili di uscita:
'      ===
'
'   Procedure utilizzate:
'      OutputMat
'
' ------------------------------------------------------------------------------
'
SUB PrintMat (A(), F$)
   
    LOCATE 25, 1
    F = FREEFILE
    OPEN "O", #F, "CON"
    CALL OutputMat(A(), F, F$)
    CLOSE #F
    PRINT

END SUB

' ================================ ProdottoCostMat =============================
'
'   Procedura per il prodotto di una costante per un array
'
'   Variabili di ingresso:
'      K         costante da moltiplicare
'      A()       array da moltiplicare
'
'   Variabili di uscita:
'      B()       array prodotto
'
'   Procedure utilizzate:
'      DuplicaMat
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB ProdottoCostMat (K, A(), B())

    ' determina il numero di indici e di righe e colonne degli array A e B
    ' controlla che il numero di righe e colonne di A e B sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 THEN
       CLS
       PRINT "ERRORE 1 in ProdottoCostMat - limiti inferiori di A o B maggiori di 1"
       END
    END IF
    IF NRA <> NRB OR NCA <> NCB THEN
       CLS
       PRINT "ERRORE 2 in ProdottoCostMat - numero di righe e colonne di A e B"
       PRINT "                              non compatibili tra loro"
       END
    END IF

    ' esegue il prodotto
    IF DA = 1 AND DB = 1 THEN
       CALL ProdottoCostMat1(K, A(), NRA, B())
    ELSEIF DA = 2 AND DB = 1 THEN
       DIM E(NRA)
       CALL DuplicaMat(A(), E())
       CALL ProdottoCostMat1(K, E(), NRA, B())
    ELSEIF DA = 1 AND DB = 2 THEN
       DIM E(NRA)
       CALL ProdottoCostMat1(K, A(), NRA, E())
       CALL DuplicaMat(E(), B())
    ELSE
       CALL ProdottoCostMat2(K, A(), NRA, NCA, B())
    END IF

END SUB

SUB ProdottoCostMat1 (K, A(), NRA, B())

    FOR R = 1 TO NRA
       B(R) = K * A(R)
    NEXT R

END SUB

SUB ProdottoCostMat2 (K, A(), NRA, NCA, B())

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          B(R, C) = K * A(R, C)
       NEXT C
    NEXT R

END SUB

' ================================ ProdottoMat =================================
'
'   Procedura per il prodotto tra due array (righe per colonne)
'
'   Variabili di ingresso:
'      A()          primo array da moltiplicare
'      B()          secondo array da moltiplicare
'
'   Variabili di uscita:
'      C()          array risultante
'
'   Procedure utilizzate:
'      DuplicaMat
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB ProdottoMat (A(), B(), C())
  
    ' determina il numero di indici e di righe e colonne degli array A, B e C
    ' controlla che il numero di righe e colonne di A, B e C siano corretti
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    CALL LimitiMat(C(), DC, LRC, LCC, NRC, NCC)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 OR LRC > 1 OR LCC > 1 THEN
       CLS
       PRINT "ERRORE 1 in ProdottoMat - limiti inferiori di A, B o C maggiori di 1"
       END
    END IF
    IF NCA <> NRB OR NRA <> NRC OR NCB <> NCC THEN
       CLS
       PRINT "ERRORE 2 in ProdottoMat - numero di righe e colonne di A, B e C"
       PRINT "                          non compatibili tra loro"
       END
    END IF
  
    ' calcola il prodotto
    IF DA = 1 AND DB = 2 THEN
       CALL ProdottoMat1(A(), B(), NRA, NCB, C())
    ELSEIF DA = 2 AND DB = 1 THEN
       CALL ProdottoMat2(A(), B(), NRA, NCA, C())
    ELSE
       CALL ProdottoMat3(A(), B(), NRA, NCB, NCA, C())
    END IF

END SUB

SUB ProdottoMat1 (A(), B(), NRA, NCB, C())

    DIM D(NRA, NCB)
    FOR R = 1 TO NRA
       FOR C = 1 TO NCB
          D(R, C) = A(R) * B(1, C)
       NEXT C
    NEXT R
    CALL DuplicaMat(D(), C())
  
END SUB

SUB ProdottoMat2 (A(), B(), NRA, NCA, C())

    DIM D(NRA)
    FOR R = 1 TO NRA
       FOR K = 1 TO NCA
          D(R) = D(R) + A(R, K) * B(K)
       NEXT K
    NEXT R
    CALL DuplicaMat(D(), C())

END SUB

SUB ProdottoMat3 (A(), B(), NRA, NCB, NCA, C())

    DIM D(NRA, NCB)
    FOR R = 1 TO NRA
       FOR C = 1 TO NCB
          FOR K = 1 TO NCA
             D(R, C) = D(R, C) + A(R, K) * B(K, C)
          NEXT K
       NEXT C
    NEXT R
    CALL DuplicaMat(D(), C())

END SUB

' ================================ SommaMat ====================================
'
'   Procedura per la somma di due array monodimensionali o bidimensionali
'
'   Variabili di ingresso:
'      A()    primo array da sommare
'      B()    secondo array da sommare
'
'   Variabili di uscita:
'      C()    array risultante
'
'   Procedure utilizzate:
'      DuplicaMat
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB SommaMat (A(), B(), C())
   
    ' determina il numero di indici e di righe e colonne degli array A, B e C
    ' controlla che il numero di righe e colonne di A, B e C sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    CALL LimitiMat(C(), DC, LRC, LCC, NRC, NCC)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 OR LRC > 1 OR LCC > 1 THEN
       CLS
       PRINT "ERRORE 1 in SommaMat - limiti inferiori di A, B o C maggiori di 1"
       END
    END IF
    IF NCA <> NCB OR NCB <> NCC OR NRA <> NRB OR NRB <> NRC THEN
       CLS
       PRINT "ERRORE 2 in SommaMat - numero di righe e colonne di A, B e C"
       PRINT "                       non compatibili tra loro"
       END
    END IF

    ' effettua la somma dei due array
    IF DA = 1 AND DB = 1 THEN
       CALL SommaMat1(A(), B(), NRA, C())
    ELSEIF DA = 2 AND DB = 1 THEN
       DIM E(NRA)
       CALL DuplicaMat(A(), E())
       CALL SommaMat1(E(), B(), NRA, C())
    ELSEIF DA = 1 AND DB = 2 THEN
       DIM E(NRA)
       CALL DuplicaMat(B(), E())
       CALL SommaMat1(A(), E(), NRA, C())
    ELSE
       CALL SommaMat2(A(), B(), NRA, NCA, C())
    END IF

END SUB

SUB SommaMat1 (A(), B(), NRA, C())

   DIM D(NRA)
   FOR R = 1 TO NRA
      D(R) = A(R) + B(R)
   NEXT R
   CALL DuplicaMat(D(), C())

END SUB

SUB SommaMat2 (A(), B(), NRA, NCA, C())
  
   FOR R = 1 TO NRA
      FOR C = 1 TO NCA
          C(R, C) = A(R, C) + B(R, C)
      NEXT C
   NEXT R

END SUB

' ================================ SottraeMat ==================================
'
'   Procedura per la sottrazione di due array
'
'   Variabili di ingresso:
'      A()       primo array
'      B()       secondo array da sottrarre al primo
'
'   Variabili di uscita:
'      C()       array risultante
'
'   Procedure utilizzate:
'      DuplicaMat
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB SottraeMat (A(), B(), C())
  
    ' determina il numero di indici e di righe e colonne degli array A, B e C
    ' controlla che il numero di righe e colonne di A, B e C siano corrette
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    CALL LimitiMat(C(), DC, LRC, LCC, NRC, NCC)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 OR LRC > 1 OR LCC > 1 THEN
       CLS
       PRINT "ERRORE 1 in SottraeMat - limiti inferiori di A, B o C maggiori di 1"
       END
    END IF
    IF NCA <> NCB OR NCB <> NCC OR NRA <> NRB OR NRB <> NRC THEN
       CLS
       PRINT "ERRORE 2 in SottraeMat - numero di righe e colonne di A, B e C"
       PRINT "                         non compatibili tra loro"
       END
    END IF
  
    ' effettua la sottrazione
    IF DA = 1 AND DB = 1 THEN
       CALL SottraeMat1(A(), B(), NRA, C())
    ELSEIF DA = 2 AND DB = 1 THEN
       DIM E(NRA)
       CALL DuplicaMat(A(), E())
       CALL SottraeMat1(E(), B(), NRA, C())
    ELSEIF DA = 1 AND DB = 2 THEN
       DIM E(NRA)
       CALL DuplicaMat(B(), E())
       CALL SottraeMat1(A(), E(), NRA, C())
    ELSE
       CALL SottraeMat2(A(), B(), NRA, NCA, C())
    END IF

END SUB

SUB SottraeMat1 (A(), B(), NRA, C())

    DIM D(NRA)
    FOR R = 1 TO NRA
       D(R) = A(R) - B(R)
    NEXT R
    CALL DuplicaMat(D(), C())

END SUB

SUB SottraeMat2 (A(), B(), NRA, NCA, C())

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          C(R, C) = A(R, C) - B(R, C)
       NEXT C
    NEXT R

END SUB

' ================================ TrasponeMat =================================
'
'   Procedura per la trasposizione di una matrice
'
'   Variabili di ingresso:
'      A()       matrice da trasporre
'
'   Variabili di uscita:
'      B()       matrice trasposta
'
'   Procedure utilizzate:
'      DuplicaMat
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB TrasponeMat (A(), B())

    ' determina il numero di indici e di righe e colonne delle matrici A e B
    ' controlla che il numero di righe e colonne di A e B siano corretti
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    CALL LimitiMat(B(), DB, LRB, LCB, NRB, NCB)
    IF LRA > 1 OR LCA > 1 OR LRB > 1 OR LCB > 1 THEN
       CLS
       PRINT "ERRORE 1 in TrasponeMat - limiti inferiori di A o B maggiori di 1"
       END
    END IF
    IF NCA <> NRB OR NRA <> NCB THEN
       CLS
       PRINT "ERRORE 2 in TrasponeMat - numero di righe e colonne di A e B"
       PRINT "                          non compatibili tra loro"
       END
    END IF

    ' effettua la trasposizione
    IF DA = 1 THEN
       CALL TrasponeMat1(A(), NRA, B())
    ELSE
       CALL TrasponeMat2(A(), NRA, NRB, B())
    END IF

END SUB

SUB TrasponeMat1 (A(), NRA, B())

    DIM D(1, NRA)
    FOR R = 1 TO NRA
       D(1, R) = A(R)
    NEXT R
    CALL DuplicaMat(D(), B())

END SUB

SUB TrasponeMat2 (A(), NRA, NCA, B())
      
    DIM D(NCA, NRA)
    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          D(C, R) = A(R, C)
       NEXT C
    NEXT R
    CALL DuplicaMat(D(), B())

END SUB

' ================================ WriteMat ====================================
'
'   Procedura per memorizzare su un file i valori degli elementi
'   di un array monodimensionale o bidimensionale;
'   l'array viene scritto su un file gia` aperto nel programma principale
'
'   Variabili di ingresso:
'      A()       array da inviare al file
'      F         buffer del file a cui inviare l'array
'
'   Variabili di uscita:
'      ===
'
'   Procedure utilizzate:
'      LimitiMat
'
' ------------------------------------------------------------------------------
'
SUB WriteMat (A(), F)

    ' determina il numero di indici e di righe e colonne dell'array A
    ' controlla che il numero di righe e colonne di A sia corretto
    CALL LimitiMat(A(), DA, LRA, LCA, NRA, NCA)
    IF LRA > 1 OR LCA > 1 THEN
       CLS
       PRINT "ERRORE 1 in WriteMat - limiti inferiori di A maggiori di 1"
       END
    END IF

    ' effettua l'output su file dell'array
    IF DA = 1 THEN
       CALL WriteMat1(A(), F, NRA)
    ELSE
       CALL WriteMat2(A(), F, NRA, NCA)
    END IF

END SUB

SUB WriteMat1 (A(), F, NRA)

    FOR R = 1 TO NRA
       WRITE #F, A(R)
    NEXT R

END SUB

SUB WriteMat2 (A(), F, NRA, NCA)

    FOR R = 1 TO NRA
       FOR C = 1 TO NCA
          WRITE #F, A(R, C)
       NEXT C
    NEXT R

END SUB

