'                                  PROGEN.BAS
'
'  procedure del programma TELGEN, utilizzate anche nel programma TELSPA
'
'  ver. 2.0                                                     rev. 02.98

'  Attenzione: cambiato numero di variabili di scambio nelle procedure
'     InputCarGen, InputAsteGen, OutputAsteGen


' ------------------ Dichiarazione delle procedure utilizzate ------------------

' procedure del file MATRIX.BAS
DECLARE SUB AzzeraMat (A!())

' ================================ InputAsteGen ================================
'  Procedura per la lettura dei dati relativi alle aste
'
'  N.B.  a partire dalla versione 2.0, lo standard di input prevede di assegnare
'        prima il tipo di asta e poi gli estremi (ma rimane possibile il
'        contrario per compatibilit con la versione precedente). Inoltre gli
'        array E1(), E2() sono sostituiti dall'array Estr(), il cui secondo
'        indice rappresenta il numero d'ordine dell'estremo ( cos possibile
'        avere elementi con pi di due estremi)
' ------------------------------------------------------------------------------
SUB InputAsteGen (Incr, Contr, JZ, LZ, Estr(), NT(), TA$(), Wnkl, B(), K(), TrRig, TrRig(), Ates(), Acom(), ER)

   ' controlla ammissibilit dell'identificatore del tipo di asta
   Wnkl = 0
   TrRig = 0
   FOR J = 1 TO JZ
      INPUT #1, Temp$
      Temp$ = UCASE$(Temp$)
      IF Temp$ = "R" THEN Temp$ = "TR"
      IF Temp$ = "T" OR Temp$ = "W" OR Temp$ = "C1" OR Temp$ = "C2" OR Temp$ = "P" OR Temp$ = "TR" OR Temp$ = "WR" OR Temp$ = "Q8" THEN
         TA$(J) = Temp$
         IF TA$(J) = "Q8" THEN NumNodi = 8 ELSE NumNodi = 2
         FOR nodo = 1 TO NumNodi
            INPUT #1, Estr(J, nodo)
         NEXT nodo
         INPUT #1, NT(J)
      ELSE
         NumNodi = 2
         Estr(J, 1) = VAL(Temp$)
         INPUT #1, Estr(J, 2), TA$(J), NT(J)
         TA$(J) = UCASE$(TA$(J))
         IF TA$(J) = "R" THEN TA$(J) = "TR"
      END IF
      IF Contr = 1 THEN
         PRINT #2, "asta"; J, "   estremi: ";
         FOR nodo = 1 TO NumNodo
            PRINT #2, Estr(J, nodo);
         NEXT nodo
         PRINT #2,
         PRINT #2, "asta tipo "; CHR$(34); TA$(J); CHR$(34),
         PRINT #2, "    sezione tipo"; NT(J)
      END IF
      IF TA$(J) <> "T" AND TA$(J) <> "W" AND TA$(J) <> "C1" AND TA$(J) <> "C2" AND TA$(J) <> "P" AND TA$(J) <> "TR" AND TA$(J) <> "WR" AND TA$(J) <> "Q8" THEN
         PRINT "Il codice che identifica il tipo di asta per l'asta"; J;
         PRINT " non  ammissibile"
         ER = 1
      END IF
      L = NT(J)
      IF L < 1 OR L > LZ THEN
         PRINT "Tipo di sezione inaccettabile per la trave "; J
         ER = 1
      ELSE
         IF LEFT$(TA$(J), 1) = "W" THEN
            Wnkl = 1
            INPUT #1, B(J), K(J)
            IF Contr = 1 THEN
               PRINT #2, "   asta su suolo alla Winkler    B ="; B(J); "   K ="; K(J)
            END IF
         END IF
         IF RIGHT$(TA$(J), 1) = "R" THEN
            TrRig = 1
            INPUT #1, TrRig(J, 1), TrRig(J, 2)
            IF Contr = 1 THEN
               PRINT #2, "   asta con tratti rigidi       sl ="; TrRig(J, 1); "  tl ="; TrRig(J, 2)
            END IF
         END IF
      END IF
      ' nel caso di carico incrementale, con Incr=1, legge armature
      IF Incr = 1 THEN
         INPUT #1, Ates(J), Acom(J)
         IF Contr = 1 THEN
            PRINT #2, "armatura tesa"; Ates(J), "   compressa "; Acom(J)
         END IF
      END IF
   NEXT J

END SUB

' ================================ InputCarGen =================================
'   Procedura per la lettura dei carichi nodali e sulle aste;
'   controlla che i carichi siano applicati a nodi ed aste esistenti
'
'   Modificata per consentire calcolo con incrementi di carico
'   Incr<>0  =>  incrementi di carico
' ------------------------------------------------------------------------------
SUB InputCarGen (Incr, MoAn, Contr, IZ, JZ, QN, QA, nMod, F(), P(), nPassi, PassoOut, ER)
 
   INPUT #1, V$
   IF UCASE$(LEFT$(V$, 1)) = "M" THEN
      MoAn = -1
      PosUg = INSTR(V$, "=")
      nMod = VAL(RIGHT$(V$, LEN(V$) - PosUg))
      IF nMod < 1 THEN ER = 1
      IF Contr = 1 THEN
         PRINT #2, "richiesta di analisi modale: "; CHR$(34); V$; CHR$(34)
         PRINT #2, "richiesta analisi modale con uso di"; nMod; " modi"
      END IF
      INPUT #1, QN, QA
   ELSE
      MoAn = 0
      QN = VAL(V$)
      INPUT #1, QA
   END IF
   IF Incr <> 0 THEN
      INPUT #1, nPassi, PassoOut
      IF Contr = 1 THEN PRINT #2, "numero passi: "; nPassi; " - stampa ogni"; PassoOut; " passi"
   END IF
   CALL AzzeraMat(F())
   CALL AzzeraMat(P())
   IF QN <> 0 THEN
      IF Contr = 1 THEN PRINT #2, QN; " carichi nodali"
      FOR Q = 1 TO QN
         INPUT #1, I, F1, F2, F3
         IF I < 1 OR I > IZ THEN
            PRINT "Carico inaccettabile perch applicato al nodo"; I
            ER = 1
         ELSE
            F(I, 1) = F1
            F(I, 2) = F2
            F(I, 3) = F3
         END IF
         IF Contr = 1 THEN
            PRINT #2, "   nodo"; I, "Fx ="; F1, "Fy ="; F2, "M ="; F3
         END IF
      NEXT Q
   END IF
   IF QA <> 0 THEN
      IF Contr = 1 THEN PRINT #2, QA; " carichi distribuiti sulle aste"
      FOR Q = 1 TO QA
         INPUT #1, J, P1, P2
         IF J < 1 OR J > JZ THEN
            PRINT "Carico inaccettabile perch applicato all'asta"; J
            ER = 1
         ELSE
            P(J, 1) = P1
            P(J, 2) = P2
         END IF
         IF Contr = 1 THEN
            PRINT #2, "   asta"; J, "px ="; P1, "py ="; P2
         END IF
      NEXT Q
   END IF

END SUB

' ================================ InputIndGen =================================
'   Procedura per la lettura delle indicazioni generali
' ------------------------------------------------------------------------------
SUB InputIndGen (IZ, JZ, KZ, LZ)
  
   INPUT #1, IZ, JZ, KZ, LZ
   IF Contr = 1 THEN
      PRINT #2, "numero di nodi:"; IZ
      PRINT #2, "numero di aste:"; JZ
      PRINT #2, "numero di traversi orizzontali inestensibili:"; KZ
      PRINT #2, "numero di tipi di sezione:"; LZ
   END IF

END SUB

' ================================ InputMasseGen ===============================
'   Procedura per la lettura delle masse (per l'analisi modale)
' ------------------------------------------------------------------------------
SUB InputMasseGen (Contr, KZ, Mas())
 
   FOR K = 1 TO KZ
      INPUT #1, Mas(K)
      IF Contr = 1 THEN
         PRINT #2, "traverso"; K, "m ="; Mas(K)
      END IF
   NEXT K

END SUB

' ================================ InputNodiGen ================================
'   Procedura per la lettura dei dati relativi ai nodi
' ------------------------------------------------------------------------------
SUB InputNodiGen (Contr, IZ, X(), Y(), V$(), VCed, KV(), ER)
 
   VCed = 0
   FOR I = 1 TO IZ
      INPUT #1, X(I), Y(I), V$(I)
      V$(I) = UCASE$(V$(I))
      IF Contr = 1 THEN
         PRINT #2, "nodo"; I, "x ="; X(I), "y ="; Y(I), "vincolo "; V$(I)
      END IF
      FOR K = 1 TO 3
         EV$ = MID$(V$(I), K, 1)
         IF EV$ = "1" OR EV$ = "0" THEN
            KV(I, K) = 0
         ELSEIF EV$ = "C" THEN
            VCed = 1
            INPUT #1, KV(I, K)
            IF Contr = 1 THEN
               PRINT #2, "      costante elastica"; K; " ="; KV(I, K)
            END IF
         ELSE
            PRINT "Elemento"; K; " del codice vincolo nodo"; I; " non ammissibile"
            ER = 1
         END IF
      NEXT K
   NEXT I

END SUB

' ================================ InputTraversiGen ============================
'   Procedura per la lettura dei dati relativi a traversi inestensibili
' ------------------------------------------------------------------------------
SUB InputTraversiGen (Contr, KZ, NI())
 
   IF KZ <> 0 THEN
      I = 0
      FOR K = 1 TO KZ
         IF Contr = 1 THEN
            PRINT #2, "traverso orizzontale inestensibile"; K; " :  ";
         END IF
         DO
            I = I + 1
            INPUT #1, NI(I)
            IF Contr = 1 AND NI(I) <> 0 THEN PRINT #2, NI(I);
         LOOP UNTIL NI(I) = 0
         IF Contr = 1 THEN PRINT #2,
      NEXT K
   END IF

END SUB

' ================================ OutputAsteGen ===============================
'   Procedura per la stampa dei dati delle aste
'
'  N.B.  a partire dalla versione 2.0, gli array E1(), E2() sono sostituiti
'        dall'array Estr(), il cui secondo indice rappresenta il numero d'ordine
'        dell'estremo ( cos possibile avere elementi con pi di due estremi)
' ------------------------------------------------------------------------------
SUB OutputAsteGen (Incr, SM, DefTag, Wnkl, TrRig, JZ, NT(), TA$(), Estr(), FS$(), ZB(), ZH(), ZA(), ZAT(), ZI(), B(), K(), TrRig(), Ates(), Acom())
 
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "DATI RELATIVI ALLE TRAVI": PRINT #2,
   PRINT #2, "                              b     h     area ";
   IF DefTag = 1 THEN PRINT #2, "   A/Chi ";
   PRINT #2, "   inerzia ";
   IF Wnkl = 1 THEN PRINT #2, "   B      K  ";
   IF TrRig = 1 THEN PRINT #2, "  tr. rig (m)";
   IF Incr = 1 THEN PRINT #2, "  Armatura (cm2)";
   PRINT #2,
   PRINT #2, "asta  tipo  estremi  forma    m     m      m2  ";
   IF DefTag = 1 THEN PRINT #2, "     m2  ";
   PRINT #2, "      m4   ";
   IF Wnkl = 1 THEN
      IF SM = 0 THEN
         PRINT #2, "   m    N/cm3";
      ELSE
         PRINT #2, "   m    kg/cm3";
      END IF
   END IF
   IF TrRig = 1 THEN PRINT #2, "  sin.   des.";
   IF Incr = 1 THEN PRINT #2, "    tes.    com.";
   PRINT #2, : PRINT #2,
   FOR J = 1 TO JZ
      L = NT(J)
      IF TA$(J) = "Q8" THEN NumNodi = 8 ELSE NumNodi = 2
      PRINT #2, USING "###     \\ "; J; TA$(J);
      FOR nodo = 1 TO NumNodi
         PRINT #2, USING " ###"; Estr(J, nodo);
      NEXT nodo
      PRINT #2, USING "    !  "; FS$(L);
      IF FS$(L) = "R" THEN
         PRINT #2, USING " ##.## ##.##"; ZB(L); ZH(L);
      ELSE
         PRINT #2, "  ----  ----";
      END IF
      PRINT #2, USING " ###.####"; ZA(L);
      IF DefTag = 1 THEN
         IF LEFT$(TA$(J), 1) = "W" THEN
            PRINT #2, "    ---- ";
         ELSE
            PRINT #2, USING " ###.####"; ZAT(L);
         END IF
      END IF
      PRINT #2, USING " ###.######"; ZI(L);
      IF Wnkl = 1 THEN
         IF LEFT$(TA$(J), 1) = "W" THEN
            IF SM = 0 THEN
               PRINT #2, USING " ##.##  ###.#"; B(J); K(J);
            ELSE
               PRINT #2, USING " ##.##  ##.##"; B(J); K(J);
            END IF
         ELSE
            PRINT #2, "  ----   ----";
         END IF
      END IF
      IF TrRig = 1 THEN
         IF RIGHT$(TA$(J), 1) = "R" THEN
            PRINT #2, USING " ##.##  ##.##"; TrRig(J, 1); TrRig(J, 2);
         ELSE
            PRINT #2, "  ----   ----";
         END IF
      END IF
      IF Incr = 1 THEN
         PRINT #2, USING "   ###.#"; Ates(J); Acom(J);
      END IF
      PRINT #2,
   NEXT J

END SUB

' ================================ OutputCarGen ================================
'   Procedura per la stampa dei carichi nodali e sulle aste
' ------------------------------------------------------------------------------
SUB OutputCarGen (SM, CAR, IZ, JZ, QN, QA, F(), P())

   IF SM = 0 THEN
      F$ = "    ######.##"
   ELSE
      F$ = "    #####.###"
   END IF

   IF QN <> 0 THEN
      PRINT #2, "CARICHI NODALI": PRINT #2,
      IF SM = 0 THEN
         PRINT #2, "nodo        Fx (kN)      Fy (kN)      M (kNm)": PRINT #2,
      ELSE
         PRINT #2, "nodo        Fx (t)       Fy (t)       M (tm)": PRINT #2,
      END IF
      FOR I = 1 TO IZ
         IF F(I, 1) <> 0 OR F(I, 2) <> 0 OR F(I, 3) <> 0 THEN
            PRINT #2, USING "###  "; I;
            PRINT #2, USING F$; F(I, 1); F(I, 2); F(I, 3)
         END IF
      NEXT I
      PRINT #2, : PRINT #2,
   END IF
   IF QA <> 0 THEN
      PRINT #2, "CARICHI SULLE ASTE": PRINT #2,
      IF SM = 0 THEN
         PRINT #2, "asta       px (kN/m)    py (kN/m)": PRINT #2,
      ELSE
         PRINT #2, "asta       px (t/m)     py (t/m)": PRINT #2,
      END IF
      FOR J = 1 TO JZ
         IF P(J, 1) <> 0 OR P(J, 2) <> 0 THEN
            PRINT #2, USING "###  "; J;
            PRINT #2, USING F$; P(J, 1); P(J, 2)
         END IF
      NEXT J
   END IF
   PRINT #2,

END SUB

' ================================ OutputMasseGen ==============================
'   Procedura per la stampa delle masse
' ------------------------------------------------------------------------------
SUB OutputMasseGen (KZ, Mas())

   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "MASSE DI PIANO   ": PRINT #2,
   PRINT #2, "  traverso    massa (t)": PRINT #2,
   FOR K = 1 TO KZ
      PRINT #2, USING "     ##    ######.###"; K; Mas(K)
   NEXT K

END SUB

' ================================ OutputNodiGen ===============================
'   Procedura per la stampa dei dati dei nodi
' ------------------------------------------------------------------------------
SUB OutputNodiGen (IZ, X(), Y(), V$(), VCed, KV())
 
   PRINT #2, "COORDINATE E VINCOLI DEI NODI": PRINT #2,
   PRINT #2, "nodo      x (m)       y (m)     vincolo";
   IF VCed = 1 THEN PRINT #2, "      rigidezza del vincolo";
   PRINT #2, : PRINT #2,
   FOR I = 1 TO IZ
      PRINT #2, USING "###    #####.##    #####.##       \ \  "; I; X(I); Y(I); V$(I);
      IF VCed <> 0 THEN
         FOR K = 1 TO 3
            IF KV(I, K) <> 0 THEN
               PRINT #2, USING " ##.####^^^^"; KV(I, K);
            ELSE
               PRINT #2, "       -    ";
            END IF
         NEXT K
      END IF
      PRINT #2,
   NEXT I

END SUB

' ================================ OutputRisGen ================================
'   Procedura per la stampa dei risultati
'
'   N.B.    Outp indica cosa stampare
'              0 oppure j ( > 0 ) = tutto
'              -1 = inviluppo modale (esclude azioni vincoli esterni e mutui)
' ------------------------------------------------------------------------------
SUB OutputRisGen (SM, Outp, IZ, JZ, KZ, NL, V$(), KV(), NI(), N(), R(), M1(), M2(), T1(), T2(), N1(), N2(), F())

   DIM V(3)
   IF SM = 0 THEN
      F$ = " #######.##"
   ELSE
      F$ = " ######.###"
   END IF
 
   PRINT #2, : PRINT #2,
   PRINT #2, "SPOSTAMENTI E ROTAZIONI DEI NODI": PRINT #2,
   PRINT #2, "nodo         vx (mm)     vy (mm)   rotaz.x1000": PRINT #2,
   FOR I = 1 TO IZ
      FOR K = 1 TO 3
         IF N(I, K) = 0 THEN V(K) = 0 ELSE V(K) = R(N(I, K)) * 1000
      NEXT K
      PRINT #2, USING "###       #####.###   #####.###   #####.###"; I; V(1); V(2); V(3)
   NEXT I
   ' stampa caratteristiche di sollecitazione
   PRINT #2, : PRINT #2, : PRINT #2,
   PRINT #2, "CARATTERISTICHE DI SOLLECITAZIONE NELLE ASTE": PRINT #2,
   IF SM = 0 THEN
      PRINT #2, "asta      M1 (kNm)   M2 (kNm)    V1 (kN)    V2 (kN)    N1 (kN)    N2 (kN)"
   ELSE
      PRINT #2, "asta      M1 (tm)    M2 (tm)     V1 (t)     V2 (t)     N1 (t)     N2 (t)"
   END IF
   PRINT #2,
   FOR J = 1 TO JZ
      PRINT #2, USING "###   "; J;
      PRINT #2, USING F$; M1(J); M2(J); T1(J); T2(J); N1(J); N2(J)
   NEXT J
   ' stampa azioni su eventuali vincoli elastici
   PrTit = 0
   FOR I = 1 TO IZ
      V = 0
      FOR K = 1 TO 3
         IF MID$(V$(I), K, 1) = "C" THEN V(K) = 1 ELSE V(K) = 0
         V = V + V(K)
      NEXT K
      IF V <> 0 THEN
         IF PrTit = 0 THEN
            PRINT #2, : PRINT #2, : PRINT #2,
            PRINT #2, "AZIONI SUI VINCOLI ELASTICI": PRINT #2,
            PRINT #2, "nodo        Fx (kN)      Fy (kN)      M (kNm)": PRINT #2,
            PrTit = 1
         END IF
         PRINT #2, USING "###  "; I;
         FOR K = 1 TO 3
            IF V(K) = 0 THEN
               PRINT #2, "         ----";
            ELSE
               F = R(N(I, K)) * KV(I, K)
               PRINT #2, USING "  " + F$; F;
               F(I, K) = F(I, K) - F
            END IF
         NEXT K
         PRINT #2,
      END IF
   NEXT I
   IF Outp < 0 THEN EXIT SUB
   ' stampa azioni su vincoli esterni ed eventuale squilibrio
   PrTit = 0
   Squil = 0
   FOR I = 1 TO IZ
      V = 0
      FOR K = 1 TO 3
         IF MID$(V$(I), K, 1) = "1" THEN V(K) = 1 ELSE V(K) = 0
         V = V + V(K)
      NEXT K
      IF V <> 0 THEN
         IF PrTit = 0 THEN
            PRINT #2, : PRINT #2, : PRINT #2,
            PRINT #2, "AZIONI SUI VINCOLI ESTERNI": PRINT #2,
            IF SM = 0 THEN
               PRINT #2, "nodo        Fx (kN)      Fy (kN)      M (kNm)": PRINT #2,
            ELSE
               PRINT #2, "nodo        Fx (t)       Fy (t)       M (tm)": PRINT #2,
            END IF
            PrTit = 1
         END IF
         PRINT #2, USING "###  "; I;
      END IF
      FOR K = 1 TO 3
         IF V(K) = 0 THEN
            IF N(I, K) > NL AND ABS(F(I, K)) > .01 THEN Squil = 1
            IF V <> 0 THEN PRINT #2, "         ----";
         ELSE
            PRINT #2, USING "  " + F$; F(I, K);
            F(I, K) = 0
         END IF
      NEXT K
      IF V <> 0 THEN PRINT #2,
   NEXT I
   IF Squil = 1 THEN
      PRINT #2, : PRINT #2,
      PRINT #2, "SQUILIBRIO NEI NODI": PRINT #2,
      IF SM = 0 THEN
         PRINT #2, "nodo        Fx (kN)      Fy (kN)      M (kNm)": PRINT #2,
      ELSE
         PRINT #2, "nodo        Fx (t)       Fy (t)       M (tm)": PRINT #2,
      END IF
      FOR I = 1 TO IZ
         V = 0
         FOR K = 1 TO 3
            IF N(I, K) > NL AND ABS(F(I, K)) > .01 THEN V(K) = 1 ELSE V(K) = 0
            V = V + V(K)
         NEXT K
         IF V <> 0 THEN
            PRINT #2, USING "###  "; I;
            FOR K = 1 TO 3
               IF V(K) = 0 THEN
                  PRINT #2, "         ----";
               ELSE
                  PRINT #2, USING "  " + F$; F(I, K);
               END IF
            NEXT K
            PRINT #2,
         END IF
      NEXT I
   END IF
   ' stampa azioni su vincoli mutui ed eventuale squilibrio
   IF KZ > 0 THEN
      PRINT #2, : PRINT #2, : PRINT #2,
      PRINT #2, "AZIONI SUI VINCOLI MUTUI (TRAVERSI ORIZZONTALI)": PRINT #2,
      NN = 0
      I = 0
      FOR K = 1 TO KZ
         V = -1
         DO
            I = I + 1
            V = V + 1
         LOOP UNTIL NI(I) = 0
         IF NN < V THEN NN = V
      NEXT K
      IF NN > 4 THEN NN = 4
      PRINT #2, "traverso";
      FOR V = 1 TO NN
         IF SM = 0 THEN
            PRINT #2, "   nodo   Fx (kN)";
         ELSE
            PRINT #2, "   nodo   Fx (t) ";
         END IF
      NEXT V
      PRINT #2, : PRINT #2,
      FOR K = 1 TO KZ
         PRINT #2, USING "  ###      "; K;
         F = 0
         V = 0
         FOR I = 1 TO IZ
            IF N(I, 1) = K THEN
               V = V + 1
               IF V = 5 THEN
                  PRINT #2, : PRINT #2, "           ";
                  V = 1
               END IF
               F = F + F(I, 1)
               PRINT #2, USING "###" + F$ + "   "; I; F(I, 1);
            END IF
         NEXT I
         PRINT #2,
         IF ABS(F) > .01 THEN
            IF SM = 0 THEN
               PRINT #2, USING "           squilibrio =######.## kN"; F
            ELSE
               PRINT #2, USING "           squilibrio =#####.### t"; F
            END IF
         END IF
      NEXT K
   END IF

END SUB

' ================================ SommaModiGen ================================
'
'  Effettua la somma dei quadrati di valori relativi ai singoli modi.
'  Successivamente ne calcola la radice quadrata.
'
'  Variabili di ingresso:
'     Oper      operazione da effettuare:
'                    0 = dimensiona array inviluppo e somma quadrati
'                    1 = somma quadrati
'                    2 = effettua radice quadrata e la dispone negli array base
'     JZ        numero di aste
'     NZ        numero di gradi di libert
'     R()       componenti di movimento dei nodi
'     M1(), M2()  momento agli estremi delle aste per un modo
'     T1(), T1()  taglio agli estremi delle aste per un modo
'     N1(), N2()  sforzo normale agli estremi delle aste per un modo
'
'  Variabili interne:
'     InvR()              componenti di movimento dei nodi per tutti i modi
'     InvM1(), InvM2()    momento agli estremi delle aste per tutti i modi
'     InvT1(), InvT2()    taglio agli estremi delle aste per tutti i modi
'     InvN1(), InvN2()    sforzo normale agli estr. delle aste per tutti i modi
'
' ------------------------------------------------------------------------------
SUB SommaModiGen (Oper, JZ, NZ, R(), M1(), M2(), T1(), T2(), N1(), N2())
 
   STATIC InvR(), InvM1(), InvM2()
   STATIC InvT1(), InvT2(), InvN1(), InvN2()
   IF Oper = 0 THEN
      REDIM InvR(NZ), InvM1(JZ), InvM2(JZ)
      REDIM InvT1(JZ), InvT2(JZ), InvN1(JZ), InvN2(JZ)
   END IF
   IF Oper <= 1 THEN
      FOR I = 1 TO NZ
         InvR(I) = InvR(I) + R(I) ^ 2
      NEXT I
      FOR J = 1 TO JZ
         InvM1(J) = InvM1(J) + M1(J) ^ 2
         InvM2(J) = InvM2(J) + M2(J) ^ 2
         InvT1(J) = InvT1(J) + T1(J) ^ 2
         InvT2(J) = InvT2(J) + T2(J) ^ 2
         InvN1(J) = InvN1(J) + N1(J) ^ 2
         InvN2(J) = InvN2(J) + N2(J) ^ 2
      NEXT J
   ELSE
      FOR I = 1 TO NZ
         InvR(I) = SQR(InvR(I))
         R(I) = InvR(I)
      NEXT I
      FOR J = 1 TO JZ
         InvM1(J) = SQR(InvM1(J))
         InvM2(J) = SQR(InvM2(J))
         InvT1(J) = SQR(InvT1(J))
         InvT2(J) = SQR(InvT2(J))
         InvN1(J) = SQR(InvN1(J))
         InvN2(J) = SQR(InvN2(J))
         M1(J) = InvM1(J)
         M2(J) = InvM2(J)
         T1(J) = InvT1(J)
         T2(J) = InvT2(J)
         N1(J) = InvN1(J)
         N2(J) = InvN2(J)
      NEXT J
   END IF

END SUB

